# class Mail::Sendmail

A delivery method implementation which sends via sendmail.

To use this, first find out where the sendmail binary is on your computer, if you are on a mac or unix box, it is usually in /usr/sbin/sendmail, this will be your sendmail location.

    Mail.defaults do
      delivery_method :sendmail
    end

Or if your sendmail binary is not at '/usr/sbin/sendmail'

    Mail.defaults do
      delivery_method :sendmail, :location => '/absolute/path/to/your/sendmail'
    end

Then just deliver the email as normal:

    Mail.deliver do
      to 'mikel@test.lindsaar.net'
      from 'ada@test.lindsaar.net'
      subject 'testing sendmail'
      body 'testing sendmail'
    end

Or by calling deliver on a Mail message

    mail = Mail.new do
      to 'mikel@test.lindsaar.net'
      from 'ada@test.lindsaar.net'
      subject 'testing sendmail'
      body 'testing sendmail'
    end

    mail.deliver!

### Constants

DEFAULTS

### Attributes

settings[RW]

### Public Class Methods

call(path, arguments, destinations, encoded_message) click to toggle source

    # File lib/mail/network/delivery_methods/sendmail.rb, line 61
    def self.call(path, arguments, destinations, encoded_message)
      popen "#{path} #{arguments} #{destinations}" do |io|
        io.puts ::Mail::Utilities.to_lf(encoded_message)
        io.flush
      end
    end

new(values) click to toggle source

    # File lib/mail/network/delivery_methods/sendmail.rb, line 47
    def initialize(values)
      self.settings = self.class::DEFAULTS.merge(values)
    end

popen(command, &block) click to toggle source

    # File lib/mail/network/delivery_methods/sendmail.rb, line 69
    def self.popen(command, &block)
      IO.popen "#{command} 2>&1", 'w+', &block
    end

shellquote(address) click to toggle source

The following is an adaptation of ruby 1.9.2's shellwords.rb file, it is modified to include '+' in the allowed list to allow for sendmail to accept email addresses as the sender with a + in them.

    # File lib/mail/network/delivery_methods/sendmail.rb, line 81
    def self.shellquote(address)
      # Process as a single byte sequence because not all shell
      # implementations are multibyte aware.
      #
      # A LF cannot be escaped with a backslash because a backslash + LF
      # combo is regarded as line continuation and simply ignored. Strip it.
      escaped = address.gsub(/([^A-Za-z0-9_\s\+\-.,:\/@])/n, "\\\\\\1").gsub("\n", '')
      %Q("#{escaped}")
    end

### Public Instance Methods

deliver!(mail) click to toggle source

    # File lib/mail/network/delivery_methods/sendmail.rb, line 51
    def deliver!(mail)
      smtp_from, smtp_to, message = Mail::CheckDeliveryParams.check(mail)

      from = "-f #{self.class.shellquote(smtp_from)}"
      to = smtp_to.map { |_to| self.class.shellquote(_to) }.join(' ')

      arguments = "#{settings[:arguments]} #{from} --"
      self.class.call(settings[:location], arguments, to, message)
    end